KDE 4.9 PyKDE API Reference

- KDE's Python API

# NetAccess Class Reference

`from PyKDE4.kio import *`

Inherits: QObject
Namespace: KIO

## Detailed Description

Net Transparency.

NetAccess allows you to do simple file operation (load, save, copy, delete...) without working with KIO.Job directly. Whereas a KIO.Job is asynchronous, meaning that the developer has to connect slots for it, KIO.NetAccess provides synchronous downloads and uploads, as well as temporary file creation and removal. The functions appear to be blocking, but the Qt event loop continues running while the operations are handled. More precisely, the GUI will still repaint, but no user interaction will be possible. If you can, please use async KIO jobs instead! See the documentation of KJob.exec() for more about the dangers of NetAccess.

This class isn't meant to be used as a class but only as a simple namespace for static functions, though an instance of the class is built for internal purposes. TODO KDE5: turn into namespace, and make the qobject class private.

Port to kio done by David Faure, faure@kde.org

Provides a blocking interface to KIO file operations.

## Enumerations

StatSide | { SourceSide, DestinationSide }

## Signals

| leaveModality ()

## Methods

| __init__ (self)

## Static Methods

bool | copy (KUrl src, KUrl target, QWidget window=0)
bool | del_ (KUrl url, QWidget window)
bool | dircopy (KUrl src, KUrl target, QWidget window)
bool | dircopy (KUrl.List src, KUrl target, QWidget window=0)
bool | download (KUrl src, QString target, QWidget window)
bool | exists (KUrl url, bool source, QWidget window)
bool | exists (KUrl url, KIO.NetAccess.StatSide statSide, QWidget window)
bool | file_copy (KUrl src, KUrl target, QWidget window=0)
QString | fish_execute (KUrl url, QString command, QWidget window)
int | lastError ()
QString | lastErrorString ()
QString | mimetype (KUrl url, QWidget window)
bool | mkdir (KUrl url, QWidget window, int permissions=-1)
KUrl | mostLocalUrl (KUrl url, QWidget window)
bool | move (KUrl src, KUrl target, QWidget window=0)
bool | move (KUrl.List src, KUrl target, QWidget window=0)
| removeTempFile (QString name)
bool | stat (KUrl url, KIO.UDSEntry entry, QWidget window)
bool | synchronousRun (KIO.Job job, QWidget window, QByteArray data=0, KUrl finalURL=0, {QString:QString} metaData=0)
bool | upload (QString src, KUrl target, QWidget window)

## Signal Documentation

leaveModality | ( |  | ) |

Signal syntax:
  `QObject.connect(source, SIGNAL("leaveModality()"), target_slot)`

## Method Documentation

__init__ | ( |  | self ) |

Private constructor

## Static Method Documentation

bool copy | ( | KUrl | src,
|  | KUrl | target,
|  | QWidget | window=0
| ) |  |  |

bool del_ | ( | KUrl | url,
|  | QWidget | window
| ) |  |  |

Deletes a file or a directory in a synchronous way.

This is a convenience function for KIO.del (it saves creating a slot and testing for the job result).

Parameters:

  | url | The file or directory to delete.
  | window | main window associated with this job. This is used to automatically cache and discard authentication information as needed. If NULL, authentication information will be cached only for a short duration after which the user will again be prompted for passwords as needed.

Returns:
  true on success, false on failure.

bool dircopy | ( | KUrl | src,
|  | KUrl | target,
|  | QWidget | window
| ) |  |  |

Overloaded method, which takes a list of source URLs

bool dircopy | ( | KUrl.List | src,
|  | KUrl | target,
|  | QWidget | window=0
| ) |  |  |

Overloaded method, which takes a list of source URLs

bool download | ( | KUrl | src,
|  | QString | target,
|  | QWidget | window
| ) |  |  |

Downloads a file from an arbitrary URL (@p src) to a temporary file on the local filesystem (@p target).

If the argument for target is an empty string, download will generate a unique temporary filename in /tmp. Since target is a reference to QString you can access this filename easily. Download will return true if the download was successful, otherwise false.

Special case: If the URL is of kind file:, then no downloading is processed but the full filename is returned in target. That means you have to take care about the target argument. (This is very easy to do, please see the example below.)

Download is synchronous. That means you can use it like this: (assuming your application has a loadFile() function)

     QString tmpFile;
     if( KIO.NetAccess.download(url, tmpFile, window)) {
         loadFile(tmpFile);
         KIO.NetAccess.removeTempFile(tmpFile);
     } else {
         KMessageBox.error(this, KIO.NetAccess.lastErrorString());
     }

Of course, your user interface will still process exposure/repaint events during the download.

If the download fails, lastError() and lastErrorString() will be set.

If the url is always remote, then you could also just write the more usual way:

     KTemporaryFile tmpFile;
     if (tmpFile.open()) {
         KIO.Job* getJob = KIO.file_copy(url, KUrl(tmpFile.fileName()), -1, KIO.Overwrite | KIO.HideProgressInfo);
         getJob->ui()->setWindow(window);
         if (KIO.NetAccess.synchronousRun(getJob, 0)) {
             loadFile(tmpFile.fileName());
         } else {
             getJob->ui()->showErrorMessage();
         }
     }

Parameters:

  | src | URL Reference to the file to download.
  | target | String containing the final local location of the file. If you insert an empty string, it will return a location in a temporary spot. <B>Note:</B> you are responsible for the removal of this file when you are finished reading it using removeTempFile.
  | window | main window associated with this job. This is used to automatically cache and discard authentication information as needed. If NULL, authentication information will be cached only for a short duration after which the user will again be prompted for passwords as needed.

Returns:
  true if successful, false for failure. Use lastErrorString() to get the reason it failed.

See also:
  lastErrorString()

bool exists | ( | KUrl | url,
|  | bool | source,
|  | QWidget | window
| ) |  |  |

Tests whether a URL exists.

Parameters:

  | url | the URL we are testing
  | statSide | determines if we want to read or write. IMPORTANT: see documentation for KIO.stat for more details about this.
  | window | main window associated with this job. This is used to automatically cache and discard authentication information as needed. If NULL, authentication information will be cached only for a short duration after which the user will again be prompted for passwords as needed.

Returns:
  true if the URL exists and we can do the operation specified by

source, false otherwise

bool exists | ( | KUrl | url,
|  | KIO.NetAccess.StatSide | statSide,
|  | QWidget | window
| ) |  |  |

Tests whether a URL exists.

Parameters:

  | url | the URL we are testing
  | statSide | determines if we want to read or write. IMPORTANT: see documentation for KIO.stat for more details about this.
  | window | main window associated with this job. This is used to automatically cache and discard authentication information as needed. If NULL, authentication information will be cached only for a short duration after which the user will again be prompted for passwords as needed.

Returns:
  true if the URL exists and we can do the operation specified by

source, false otherwise

bool file_copy | ( | KUrl | src,
|  | KUrl | target,
|  | QWidget | window=0
| ) |  |  |

Alternative to upload for copying over the network. Overwrite is false, so this will fail if target exists.

This one takes two URLs and is a direct equivalent of KIO.file_copy.

Parameters:

  | src | URL Referencing the file to upload.
  | target | URL containing the final location of the file.
  | window | main window associated with this job. This is used to automatically cache and discard authentication information as needed. If NULL, authentication information will be cached only for a short duration after which the user will again be prompted for passwords as needed.

Returns:
  true if successful, false for failure

QString fish_execute | ( | KUrl | url,
|  | QString | command,
|  | QWidget | window
| ) |  |  |

Executes a remote process via the fish ioslave in a synchronous way.

Parameters:

  | url | The remote machine where the command should be executed. e.g. fish://someuser\@somehost:sshport/ some special cases exist. fish://someuser\@localhost/ will use su instead of ssh to connect and execute the command. fish://someuser\@localhost:port/ will use ssh to connect and execute the command.
  | command | The command to be executed.
  | window | main window associated with this job. This is used to automatically cache and discard authentication information as needed. If NULL, authentication information will be cached only for a short duration after which the user will again be prompted for passwords as needed.

Returns:
  The resulting output of the command that is executed.

int lastError | ( |  | ) |

Returns the error code for the last job, in case it failed.

Returns:
  the last error code

QString lastErrorString | ( |  | ) |

Returns the error string for the last job, in case it failed. Note that this is already translated.

Returns:
  the last error string, or QString()

QString mimetype | ( | KUrl | url,
|  | QWidget | window
| ) |  |  |

Determines the mimetype of a given URL.

This is a convenience function for KIO.mimetype. You should call this only when really necessary. KMimeType.findByUrl can determine extension a lot faster, but less reliably for remote files. Only when findByUrl() returns unknown (application/octet-stream) then this one should be used.

Parameters:

  | url | The URL whose mimetype we are interested in.
  | window | main window associated with this job. This is used to automatically cache and discard authentication information as needed. If NULL, authentication information will be cached only for a short duration after which the user will again be prompted for passwords as needed.

Returns:
  The mimetype name.

bool mkdir | ( | KUrl | url,
|  | QWidget | window,
|  | int | permissions=-1
| ) |  |  |

Creates a directory in a synchronous way.

This is a convenience function for KIO.mkdir (it saves creating a slot and testing for the job result).

Parameters:

  | url | The directory to create.
  | window | main window associated with this job. This is used to automatically cache and discard authentication information as needed. If NULL, authentication information will be cached only for a short duration after which the user will again be prompted for passwords as needed.
  | permissions | directory permissions.

Returns:
  true on success, false on failure.

KUrl mostLocalUrl | ( | KUrl | url,
|  | QWidget | window
| ) |  |  |

Tries to map a local URL for the given URL.

This is a convenience function for KIO.stat + parsing the resulting UDSEntry.

Parameters:

  | url | The URL we are testing.
  | window | main window associated with this job. This is used to automatically cache and discard authentication information as needed. If NULL, authentication information will be cached only for a short duration after which the user will again be prompted for passwords as needed.

Returns:
  a local URL corresponding to the same resource than the original URL, or the original URL if no local URL can be mapped

bool move | ( | KUrl | src,
|  | KUrl | target,
|  | QWidget | window=0
| ) |  |  |

Full-fledged equivalent of KIO.move. Moves or renames a list of files or directories.

Deprecated:
  use KIO.move and then KIO.NetAccess.synchronousRun (or job->exec())

bool move | ( | KUrl.List | src,
|  | KUrl | target,
|  | QWidget | window=0
| ) |  |  |

Full-fledged equivalent of KIO.move. Moves or renames a list of files or directories.

Deprecated:
  use KIO.move and then KIO.NetAccess.synchronousRun (or job->exec())

removeTempFile | ( | QString | name
| ) |  |  |

Removes the specified file if and only if it was created by KIO.NetAccess as a temporary file for a former download.

Note: This means that if you created your temporary with KTempFile, use KTempFile.unlink() or KTempFile.setAutoDelete() to have it removed.

Parameters:

  | name | Path to temporary file to remove. May not be empty.

bool stat | ( | KUrl | url,
|  | KIO.UDSEntry | entry,
|  | QWidget | window
| ) |  |  |

Tests whether a URL exists and return information on it.

This is a convenience function for KIO.stat (it saves creating a slot and testing for the job result).

Parameters:

  | url | The URL we are testing.
  | entry | The result of the stat. Iterate over the list of atoms to get hold of name, type, size, etc., or use KFileItem.
  | window | main window associated with this job. This is used to automatically cache and discard authentication information as needed. If NULL, authentication information will be cached only for a short duration after which the user will again be prompted for passwords as needed.

Returns:
  true if successful, false for failure

bool synchronousRun | ( | KIO.Job | job,
|  | QWidget | window,
|  | QByteArray | data=0,
|  | KUrl | finalURL=0,
|  | {QString:QString} | metaData=0
| ) |  |  |

This function executes a job in a synchronous way. If a job fetches some data, pass a QByteArray pointer as data parameter to this function and after the function returns it will contain all the data fetched by this job.

     KIO.Job *job = KIO.get( url );
     QMap<QString, QString> metaData;
     metaData.insert( "PropagateHttpHeader", "true" );
     if ( NetAccess.synchronousRun( job, 0, &data, &url, &metaData ) ) {
       QString responseHeaders = metaData[ "HTTP-Headers" ];
       kDebug()<<"Response header = "<< responseHeaders;
     }

Parameters:

  | job | job which the function will run. Note that after this function finishes running, job is deleted and you can't access it anymore!
  | window | main window associated with this job. This is used to automatically cache and discard authentication information as needed. If NULL, authentication information will be cached only for a short duration after which the user will again be prompted for passwords as needed.
  | data | if passed and relevant to this job then it will contain the data that was fetched by the job
  | finalURL | if passed will contain the final url of this job (it might differ from the one it was created with if there was a redirection)
  | metaData | you can pass a pointer to the map with meta data you wish to set on the job. After the job finishes this map will hold all the meta data from the job.

Returns:
  true on success, false on failure.

bool upload | ( | QString | src,
|  | KUrl | target,
|  | QWidget | window
| ) |  |  |

Uploads file src to URL target.

Both must be specified, unlike download. Note that this is assumed to be used for saving a file over the network, so overwriting is set to true. This is not the case with copy.

Parameters:

  | src | URL Referencing the file to upload.
  | target | URL containing the final location of the file.
  | window | main window associated with this job. This is used to automatically cache and discard authentication information as needed. If NULL, authentication information will be cached only for a short duration after which the user will again be prompted for passwords as needed.

Returns:
  true if successful, false for failure

## Enumeration Documentation

StatSide

Enumerator:

  SourceSide |
  DestinationSide |